<template>
  <div>
    <v-row v-if="this.userCanDeleteTest" class="my-4 mx-8" align="center">
      <v-spacer />
      <v-btn small color="primary" class="mr-4" elevation="0" @click="handleNewTest">
        Nova Prova
        <v-icon small right class="ml-3">mdi-plus</v-icon>
      </v-btn>
    </v-row>
    <!-- Show msgs -->
    <v-card-text v-if="tests.length == 0">
      <section class="noTests">
        <v-icon class="pr-2 pb-2" color="secondary" x-large>mdi-file-document-outline</v-icon>
        <p>Ops, essa disciplina ainda <b>não possui nenhuma avaliação</b> agendada.</p>
      </section>
    </v-card-text>

    <!-- Tabela para professor/admin global -->

    <v-data-table
      v-if="this.userCanDeleteTest && this.userCanAddTest && this.tests.length > 0"
      class="elevation-1 px-12 pb-6"
      calculate-widths
      :headers="headers"
      :items="tests"
      :footer-props="{ itemsPerPageText: 'Provas por página' }"
    >
      <!-- Ações -->
      <template v-slot:[`item.actions`]="{ item }">
        <div class="ehqTable py-2">
          <v-tooltip v-if="userCanDeleteTest" bottom color="primary">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="onlyShowTest(item)">mdi-eye</v-icon>
            </template>
            <span><b>Ver </b> prova</span>
          </v-tooltip>

          <v-tooltip
            v-if="
              (compareData > compareDataMethod(item.endDate) && !userCanMonitoring) ||
                (compareData > compareDataMethod(item.initialDate) && userCanDeleteTest)
            "
            bottom
            color="primary"
          >
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="handleShowResult(item)">mdi-chart-bar</v-icon>
            </template>
            <span><b>Ver</b> Desempenho</span>
          </v-tooltip>

          <v-tooltip
            v-if="compareData < compareDataMethod(item.endDate) && userCanUpdateTest"
            bottom
            color="primary"
          >
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="handleEditTest(item)">mdi-pencil</v-icon>
            </template>
            <span><b>Editar</b> prova</span>
          </v-tooltip>

          <v-tooltip
            v-if="compareData < compareDataMethod(item.initialDate) && userCanDeleteTest"
            bottom
            color="primary"
          >
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="handleDeleteTest(item)">mdi-delete</v-icon>
            </template>
            <span><b>Deletar</b> prova</span>
          </v-tooltip>
          <br v-if="userCanDeleteTest" />

          <span v-if="compareData > compareDataMethod(item.endDate)">
            <v-btn
              style="pointer-events: none;"
              class="my-1 white--text"
              color="green lighten-1"
              elevation="0"
              x-small
            >
              Já realizada
            </v-btn>
          </span>

          <span
            v-if="
              compareData > compareDataMethod(item.initialDate) &&
                compareData < compareDataMethod(item.endDate)
            "
          >
            <v-btn
              style="pointer-events: none;"
              class="my-1"
              color="blue"
              outlined
              elevation="0"
              x-small
            >
              Acontecendo
            </v-btn>
          </span>

          <v-btn
            v-if="compareData < compareDataMethod(item.initialDate)"
            :style="
              compareData < compareDataMethod(item.initialDate) ? 'pointer-events: none;' : ''
            "
            class="my-1"
            outlined
            color="red"
            elevation="0"
            x-small
            >Agendada <v-icon x-small class="pl-1">mdi-alarm</v-icon></v-btn
          >

          <v-btn
            v-if="compareData < compareDataMethod(item.initialDate)"
            outlined
            class="my-1"
            color="primary"
            elevation="0"
            x-small
            @click="monitorInitTest()"
            >Autorizar prova</v-btn
          >
        </div>
      </template>
      <!-- Questões -->
      <template v-slot:[`item.questions`]="{ item }">
        {{ item.questions.length }}
      </template>
      <!-- Data inicial -->
      <template v-slot:[`item.initialDate`]="{ item }">
        <span v-html="convertData(item.initialDate)" />
      </template>
      <!-- Data inicial -->
      <template v-slot:[`item.endDate`]="{ item }">
        <span v-html="convertData(item.endDate)" />
      </template>
    </v-data-table>
    <!-- Tabela para MONITOR -->
    <v-data-table
      v-if="!this.userCanDeleteTest && this.userCanMonitoring && this.tests.length > 0"
      class="elevation-1 px-12 pb-6"
      calculate-widths
      :headers="headersMonitoring"
      :items="tests"
      :footer-props="{ itemsPerPageText: 'Provas por página' }"
    >
      <!-- Ações -->
      <template v-slot:[`item.actions`]="{ item }">
        <div class="ehqTable py-2">
          <v-tooltip v-if="userCanDeleteTest" bottom color="primary">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small>mdi-eye</v-icon>
            </template>
            <span><b>Monitorar </b> prova</span>
          </v-tooltip>

          <span v-if="compareData > compareDataMethod(item.endDate)">
            <v-btn
              style="pointer-events: none;"
              class="my-1 white--text"
              color="green lighten-1"
              elevation="0"
              x-small
            >
              Já realizada
            </v-btn>
          </span>

          <span
            v-if="
              compareData > compareDataMethod(item.initialDate) &&
                compareData < compareDataMethod(item.endDate)
            "
          >
            <v-btn
              style="pointer-events: none;"
              class="my-1"
              color="blue"
              outlined
              elevation="0"
              x-small
            >
              Acontecendo
            </v-btn>
          </span>

          <v-btn
            v-if="compareData < compareDataMethod(item.initialDate)"
            :style="
              compareData < compareDataMethod(item.initialDate) ? 'pointer-events: none;' : ''
            "
            class="my-1"
            outlined
            color="red"
            elevation="0"
            x-small
            >Agendada <v-icon x-small class="pl-1">mdi-alarm</v-icon></v-btn
          >

          <v-btn
            v-if="compareData < compareDataMethod(item.initialDate)"
            outlined
            class="my-1"
            color="primary"
            elevation="0"
            x-small
            @click="monitorInitTest()"
            >Autorizar Início</v-btn
          >
        </div>
      </template>
      <!-- Data inicial -->
      <template v-slot:[`item.initialDate`]="{ item }">
        <span v-html="convertData(item.initialDate)" />
      </template>
      <!-- Data inicial -->
      <template v-slot:[`item.endDate`]="{ item }">
        <span v-html="convertData(item.endDate)" />
      </template>
    </v-data-table>
    <!-- Tabela para ALUNO -->
    <v-data-table
      v-if="!this.userCanDeleteTest && this.userCanResolveTest && this.tests.length > 0"
      class="elevation-1 px-12 pb-6"
      calculate-widths
      :headers="headersStudent"
      :items="tests"
      :footer-props="{ itemsPerPageText: 'Provas por página' }"
    >
      <!-- Ações -->
      <template v-slot:[`item.actions`]="{ item }">
        <div class="ehqTable py-2">
          <span v-if="compareData > compareDataMethod(item.endDate)">
            <v-btn
              style="pointer-events: none;"
              class="my-1 white--text"
              color="green lighten-1"
              elevation="0"
              x-small
            >
              Já realizada
            </v-btn>
          </span>

          <span
            v-if="
              compareData > compareDataMethod(item.initialDate) &&
                compareData < compareDataMethod(item.endDate)
            "
          >
            <v-btn
              style="pointer-events: none;"
              class="my-1"
              color="blue"
              outlined
              elevation="0"
              x-small
            >
              Acontecendo
            </v-btn>
          </span>

          <v-btn
            v-if="!hasHistory"
            class="my-1"
            outlined
            color="green"
            elevation="0"
            x-small
            @click="enterTest(item)"
            >Iniciar Prova <v-icon x-small class="pl-1">mdi-pen</v-icon>
          </v-btn>

          <v-btn
            v-if="hasHistory"
            style="pointer-events: none;"
            class="my-1"
            color="primary"
            outlined
            elevation="0"
            x-small
          >
            Prova realizada <v-icon x-small class="pl-1">mdi-check</v-icon>
          </v-btn>
        </div>
      </template>
      <!-- Data inicial -->
      <template v-slot:[`item.initialDate`]="{ item }">
        <span v-html="convertData(item.initialDate)" />
      </template>
      <!-- Data inicial -->
      <template v-slot:[`item.endDate`]="{ item }">
        <span v-html="convertData(item.endDate)" />
      </template>
    </v-data-table>
    <!-- INICIO DOS DIALOGS -->
    <v-dialog
      v-model="dialogManageTest"
      :width="widthManageTestDialog"
      @keydown.esc="closeDialogManageTest"
      @click:outside="closeDialogManageTest"
    >
      <ManageTests
        ref="refTest"
        :manageTest="manageTest"
        :itemToEdit="itemToEdit"
        @handleClose="closeDialogManageTest"
        @editTest="editTest"
        @goTab0="widthManageTestDialog = '800px'"
        @goTab1="widthManageTestDialog = '95%'"
      />
    </v-dialog>
    <!-- Mostra resultado para professor -->
    <v-dialog
      v-if="dialogShowPerformance"
      v-model="dialogShowPerformance"
      color="white"
      fullscreen
      persistent
    >
      <ShowResult
        ref="refPerformance"
        :test="testToView"
        :onlyView="onlyView"
        @handleClose="closeResultTest"
      />
    </v-dialog>
    <!-- Para aluno fazer prova -->
    <v-dialog v-if="dialogDoingTest" v-model="dialogDoingTest" color="white" fullscreen persistent>
      <ShowTest
        ref="refShow"
        :initialDate="testInitialDate"
        :endDate="testEndDate"
        :dialogShowTest="dialogDoingTest"
        :test="testToView"
        :userRole="userRole"
        :onlyView="onlyView"
        @handleClose="closeDoingTest"
      />
    </v-dialog>
    <!-- Confirma deletar usuario -->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="confirmDeleteQuestion"
    />
    <!-- {{ userCanDeleteTest }} -->
  </div>
</template>

<script>
import Ehq from '../../services/ehq'
import ManageTests from './admin/ManageTests.vue'
import ShowResult from './admin/ShowResult.vue'
import ShowTest from './testView/ShowTest.vue'
import { Utils } from '../../utils/utils'

export default {
  components: { ManageTests, ShowResult, ShowTest },
  props: { refreshByNewTest: { type: Number, default: 0 } },
  watch: {
    async refreshByNewTest() {
      /* foi criado um novo teste no arquivo Tests.vue entao precisamos atualizar a tabela */
      this.readAllTests()
    },
  },
  name: 'Tests',
  data: () => ({
    userCanReadAll: false,
    userCanAddTest: false,
    userCanDeleteTest: false,
    userCanUpdateTest: false,
    userCanMonitoring: false,
    userCanResolveTest: false,
    headers: [
      { text: 'Título', align: 'center', sortable: false, value: 'title', width: '20%' },
      {
        text: 'Numero Questões',
        align: 'center',
        sortable: false,
        value: 'questions',
        width: '16%',
      },
      {
        text: 'Data de início',
        align: 'center',
        sortable: false,
        value: 'initialDate',
        width: '20%',
      },
      {
        text: 'Data de fim',
        align: 'center',
        sortable: false,
        value: 'endDate',
        width: '20%',
      },
      { text: 'Ações', align: 'center', sortable: false, value: 'actions', width: '20%' },
    ],
    headersMonitoring: [
      { text: 'Título', align: 'center', sortable: false, value: 'title', width: '15%' },
      {
        text: 'Instruções',
        align: 'center',
        sortable: false,
        value: 'instructions',
        width: '35%',
      },
      {
        text: 'Data de início',
        align: 'center',
        sortable: false,
        value: 'initialDate',
        width: '15%',
      },
      {
        text: 'Data de fim',
        align: 'center',
        sortable: false,
        value: 'endDate',
        width: '15%',
      },
      { text: 'Ações', align: 'center', sortable: false, value: 'actions', width: '20%' },
    ],
    headersStudent: [
      { text: 'Título', align: 'center', sortable: false, value: 'title', width: '15%' },
      {
        text: 'Instruções',
        align: 'center',
        sortable: false,
        value: 'instructions',
        width: '35%',
      },
      {
        text: 'Data de início',
        align: 'center',
        sortable: false,
        value: 'initialDate',
        width: '15%',
      },
      {
        text: 'Data de fim',
        align: 'center',
        sortable: false,
        value: 'endDate',
        width: '15%',
      },
      { text: 'Ações', align: 'center', sortable: false, value: 'actions', width: '20%' },
    ],
    //tipo de questões: summation, multipleChoice, objective, trueOrFalse, dissertation
    tests: [],
    alert: {
      status: false,
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    itemToDelete: {},
    itemToView: {},
    itemToEdit: {},
    testToView: {},
    onlyView: false,
    manageTest: 'add', //add or edit
    dialogManageTest: false,
    dialogShowTest: false,
    dialogShowPerformance: false,
    dialogDoingTest: false,
    areas: [],
    userInfo: {},
    widthManageTestDialog: '800px',
    compareData: '',
    userRole: '',
    testInitialDate: '',
    testEndDate: '',
    hasHistory: false,
  }),

  async created() {
    this.generateData()
    await this.checkPrivileges()
  },

  methods: {
    async userCheckPrivileges(data, nameOfPrivilege) {
      //data = data do vue; nameOfPrivilege = nome do privilegio
      let check = false
      const routedEntity = await this.$getItem('routedEntity')
      //checa se o usuario logado na entidade pode realizar certa ação/privilégio
      routedEntity.privileges.actions.forEach((privilege) => {
        if (privilege.name == nameOfPrivilege) {
          check = true
          return
        }
      })
      this[`${data}`] = check
    },

    async checkPrivileges() {
      await this.userCheckPrivileges('userCanReadAll', 'ehqTestRead')
      await this.userCheckPrivileges('userCanAddTest', 'ehqTestCreate')
      await this.userCheckPrivileges('userCanDeleteTest', 'ehqTestDelete')
      await this.userCheckPrivileges('userCanUpdateTest', 'ehqTestUpdate')
      await this.userCheckPrivileges('userCanMonitoring', 'ehqMonitorActions')
      await this.userCheckPrivileges('userCanResolveTest', 'ehqStudentActions')
      // para Professor ou papel superior
      if (this.userCanDeleteTest && this.userCanAddTest) {
        await this.readAllTests()
      }

      // para Monitor
      if (!this.userCanDeleteTest && this.userCanMonitoring) {
        await this.monitorReadInfoTest()
        this.userRole = 'monitor'
      }

      // para Aluno
      if (!this.userCanDeleteTest && this.userCanResolveTest) {
        await this.studentStep1()
        this.userRole = 'student'
        await this.checkAlreadySendTest()
      }
    },

    // checa se já enviou a prova
    async checkAlreadySendTest() {
      try {
        let history = await this.$getItem('ehqTest')
        let user = await this.$getItem('userInfo')
        let check = false

        this.tests.forEach((test) => {
          if (test.id == history.test.test) check = true
        })

        if (history && history.test.student == user.id && check) {
          this.hasHistory = true
          console.log('já fez a prova!')
        }
      } catch (e) {
        console.log('Nao fez a prova aindaaa')
        this.hasHistory = false
      }
    },

    // FRONTEND BÁSICO

    handleNewTest() {
      this.$emit('addNewTest')
    },

    generateData() {
      let actualData = new Date()
      // actualData.getTime()
      this.compareData = actualData.getTime()
    },

    compareDataMethod(item) {
      let newData = new Date(item)
      let convert = newData.getTime()

      return convert
    },

    // deletar questão
    handleDeleteTest(item) {
      this.itemToDelete = item
      this.alert.message = `Deseja <b>deletar</b> "${item.title}" ?`
      this.alert.status = true
    },

    async confirmDeleteQuestion() {
      await this.deleteTest(this.itemToDelete.id)
      this.alert.status = false
    },

    //editar questão
    async handleEditTest(item) {
      this.itemToEdit = item
      this.manageTest = 'edit'
      this.dialogManageTest = true
    },

    // métodos p/ nova questão e editar questão
    closeDialogManageTest() {
      this.$refs.refTest.resetData()
      this.dialogManageTest = false
      this.manageTest = 'add'
      this.itemToEdit = { questions: [] }
    },

    // edit teste
    async editTest(item) {
      let initialDate = new Date(item.initialDate)
      let endDate = new Date(item.endDate)
      await this.editTestSave(
        item.id,
        initialDate.toISOString(),
        endDate.toISOString(),
        item.title,
        item.instructions
      )
      this.closeDialogManageTest()
    },

    // APENAS VISÃO da prova
    onlyShowTest(item) {
      this.dialogShowPerformance = true
      this.testToView = item
      this.onlyView = true
    },

    //ver RESULTADOS
    handleShowResult(item) {
      this.dialogShowPerformance = true
      this.testToView = item
    },

    closeResultTest() {
      this.dialogShowPerformance = false
      this.onlyView = false
      this.testToView = { id: '', questions: [] }
    },

    convertData(data) {
      let newData = new Date(data)
      let convert = newData.getTime()
      return Utils.compareDate(convert)
    },

    showTest() {
      console.log('iniciar prova')
    },

    async closeDoingTest() {
      this.dialogDoingTest = false
      this.onlyView = false
      this.testToView = { id: '', questions: [] }
      await this.checkAlreadySendTest()
    },

    // Integração BackEnd
    async readAllTests() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('ehqTestRead').id

      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Ehq.readAllTests(entityId, actionId)
        if (req.success) {
          this.tests = req.data
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async editTestSave(id, initialDate, endDate, title, instructions) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('ehqTestUpdate').id
      this.$store.commit('user/UPDATE_LOADING', true)
      try {
        let req = await Ehq.updateTest(
          entityId,
          actionId,
          id,
          initialDate,
          endDate,
          title,
          instructions
        )
        if (req.success) {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Prova editada <b>adicionada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          await this.readAllTests()
        } else {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Não foi possível <b>editar</b> a prova.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async deleteTest(id) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('ehqTestDelete').id
      this.$store.commit('user/UPDATE_LOADING', true)

      try {
        let req = await Ehq.deleteTest(entityId, actionId, id)
        if (req.success) {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Prova <b>deletada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          await this.readAllTests()
        } else {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Não foi possivel <b>deletar</b> a prova selecionada.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    //Monitor methods
    async monitorInitTest() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('ehqMonitorActions').id
      const userInfo = await this.$getItem('userInfo')
      this.$store.commit('user/UPDATE_LOADING', true)

      try {
        let req = await Ehq.monitorInitTest(entityId, actionId, userInfo.id)
        if (req.success) {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Você <b>autorizou</b> o início da prova!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async monitorReadInfoTest() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('ehqMonitorActions').id
      const userInfo = await this.$getItem('userInfo')
      this.$store.commit('user/UPDATE_LOADING', true)

      try {
        let req = await Ehq.monitorReadInfoTest(entityId, actionId, userInfo.id)
        if (req.success) {
          console.log(req, 'monitorReadInfo')
          this.tests = req.data
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    //Student Tests
    async enterTest(item) {
      this.testInitialDate = item.initialDate
      this.testEndDate = item.endDate
      await this.studentStep2EnterTest(item.id)
    },

    async studentStep1() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('ehqStudentActions').id
      const userInfo = await this.$getItem('userInfo')
      this.$store.commit('user/UPDATE_LOADING', true)

      try {
        let req = await Ehq.studentStep1(entityId, actionId, userInfo.id)
        if (req.success) {
          console.log(req, 'student Get Classes')
          this.tests = [req.data]
        } else {
          console.log(req, 'não tem prova')
          this.tests = []
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async studentStep2EnterTest(testId) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('ehqStudentActions').id
      const userInfo = await this.$getItem('userInfo')

      this.$store.commit('user/UPDATE_LOADING', true)
      try {
        let req = await Ehq.studentStep2(entityId, actionId, userInfo.id, testId)
        if (req.success) {
          this.testToView = req.data
          this.testToView = Object.assign(this.testToView, {
            title: this.tests[0].title,
            instructions: this.tests[0].instructions,
          })
          this.dialogDoingTest = true
        } else {
          if (req.data.description == "We didn't find an answer to error waitTest on model test") {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: `Aguarde o horário informado, a prova ainda <b>não</b> começou.`,
              icon: 'mdi-alert',
              color: 'test',
            })
          }
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>

<style>
.viewQuestionStyle:hover {
  font-weight: 600;
  cursor: pointer;
}

.navTests > .v-btn:hover {
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}

.ehqTable > .v-icon:hover {
  color: #ffc107 !important;
}

.ehqTable > .v-icon,
.v-btn {
  margin-right: 8px;
}

.noTests {
  font-size: 1rem;
  min-height: 100px;
  text-align: center;
}
.noTests > b {
  padding-left: 4px;
  padding-right: 4px;
}
</style>
